//javascript: 
var expSyntaxArray = [];

Element.prototype.getElementWidth = function() {
    if (typeof this.clip !== "undefined") {
	return this.clip.width;
    } else {
	if (this.style.pixelWidth) {
	    return this.style.pixelWidth;
	} else {
	    return this.offsetWidth;
	}
    }
};

Element.prototype.getElementHeight = function() {
    if (typeof this.clip !== "undefined") {
	return this.clip.height;
    } else {
	if (this.style.pixelHeight) {
	    return this.style.pixelHeight;
	} else {
	    return this.offsetHeight;
	}
    }
};

function getElementWidth(elem)
{
    if (typeof elem.clip !== "undefined") {
	return elem.clip.width;
    } else {
	if (elem.style.pixelWidth) {
	    return elem.style.pixelWidth;
	} else {
	    return elem.offsetWidth;
	}
    }
}

function getElementHeight(elem)
{
    if (typeof elem.clip !== "undefined") {
	return elem.clip.height;
    } else {
	if (elem.style.pixelHeight) {
	    return elem.style.pixelHeight;
	} else {
	    return elem.offsetHeight;
	}
    }
}

function getStyle(el,styleProp)
{
    var x = document.getElementById(el);
    if (x.currentStyle) {
	var y = x.currentStyle[styleProp];
    }
    else if (window.getComputedStyle) {
	var y = document.defaultView.getComputedStyle(x,null).getPropertyValue(styleProp);
    }
    return y;
}

function getElementPosition(elem) 
{
    var origElem = elem;

    var xl_ = 0;
    var yt_ = 0;

    while(elem && !isNaN(elem.offsetLeft) && !isNaN(elem.offsetTop)) {
        xl_ += elem.offsetLeft - elem.scrollLeft;
        yt_ += elem.offsetTop - elem.scrollTop;
        elem = elem.offsetParent;
    }

    var xr_ = xl_ + getElementWidth(origElem);
    var yb_ = yt_ + getElementHeight(origElem);

    return { xl: xl_, yt: yt_, xr: xr_, yb: yb_ };
}



function htmlToExpeditee(node,depth) 
{
    depth = (depth) ? depth : 0;

    var expSyntax = "";

    if (node.nodeType == 3) { /* text node */
        var text = node.nodeValue;

        if (text.match(/\S/)) {
	    for (var i=0; i<depth; i++) { expSyntax += "  "; }
	    expSyntax += "Text item: " + node.nodeValue + "\n";
	}
    }
    else if (node.nodeType == 1) { /* element */

	/* need to handle: img, a, li */
        /* need to dig out: text size, l/r/justified, font-face, type, colour */

        var elemName = node.Name;
	if (elemName != "SCRIPT") {

	    
	    var nodePos = getElementPosition(node); 
	    var xl = nodePos.xl;
	    var xr = nodePos.xr;
	    var yt = nodePos.yt;
	    var yb = nodePos.yb;

	    var rectSyntax = "";
	    for (var i=0; i<depth; i++) { rectSyntax += "  "; }
	    rectSyntax += "Rect item " + node.nodeName + ": ";
	    rectSyntax += xl + " " + yt + " " + xr + " " + yb + "\n";

	    expSyntax += rectSyntax;

	    var cnode = node.firstChild; 
	    while (cnode != null) {
		expSyntax += htmlToExpeditee(cnode,depth+1);  
		
		cnode = cnode.nextSibling ;
	    }

	}

    }
    /* currently do nothing for the other node types */

    return expSyntax;
}


//var body = document.body;
//alert(traverseDOM(body));